//+------------------------------------------------------------------+
//|                                                                  |
//|                           MIX                                    |
//|                                                                  |
//+------------------------------------------------------------------+
#define m  20050611
#include <WinUser32.mqh>
//----
extern int tp = 9;
extern int sh = 9;
extern double lot = 0.1;
extern double dec = 2.0;
extern double tpa = 0;
extern double balance = 0.5;
//----

extern bool CanTrall = true;    //     
extern double Depo = 40000;     //  
extern double FixPart = 10000;  //  

extern double Eq1 = 20000;      //  1
extern double Tral1 = 15000;    // 1
extern double Eq2 = 30000;      //  2
extern double Tral2 = 20000;    // 2
extern double Eq3 = 40000;      //  3
extern double Tral3 = 30000;    // 3
extern double Eq4 = 520000;     //  4
extern double Tral4 = 40000;    // 4
extern double Eq5 = 60000;      //  5
extern double Tral5   = 45000;  // 5

extern double DeltaEQ = 5000;      //    
extern double Tral6 = 3000;    //     

bool CanTrade=true;
double var;
int LastDay=0;
int Position=0;  //  


datetime lastt; 
int slip, i, ii, tic, total, kk, gle;
double lotsi = 0.0;
bool sob = false, sos = false, scb = false, scs = false;
int kb, kb_max;
double M_ob[11][8];
int ks, ks_max;
double M_os[11][8];
double max_lot_b, max_lot_s, buy_lev_min, sell_lev_max;
int buy, sell;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int kol_buy()
  {
   int kol_ob = 0;
  //----
   for(int i = 0; i < OrdersTotal(); i++)
     {
       if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) 
           break;
       //----
       if(OrderType() == OP_BUY)  
           kol_ob++;
     }
   return(kol_ob);
  }    

int kol_sell()
  {
   int kol_os = 0;
   //----
   for(int i = 0; i < OrdersTotal(); i++)
     {
       if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) 
           break;
       //----
       if(OrderType() == OP_SELL)  
           kol_os++;
     }
   return(kol_os);
  }  

//--------------------------------

void buy_array_reset()
  {
   ArrayInitialize(M_ob, 0.0);
   int kbi = 0;
   for(i = 0; i < OrdersTotal(); i++)
     {
       if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) 
           break;
       //----
       if(OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
           kbi++;
           M_ob[kbi][0] = OrderTicket();
           M_ob[kbi][1] = OrderOpenPrice();
           M_ob[kbi][2] = OrderLots();
           M_ob[kbi][3] = OrderType();
           M_ob[kbi][4] = OrderMagicNumber();
           M_ob[kbi][5] = OrderStopLoss();
           M_ob[kbi][6] = OrderTakeProfit();
           M_ob[kbi][7] = OrderProfit();
         }
     } 
   kb_max = kol_buy();
   M_ob[0][0] = kb; 
   max_lot_b = M_ob[kol_buy()][2];
   buy_lev_min = M_ob[kol_buy()][1];
   return;
  }

void sell_array_reset()
  {
   ArrayInitialize(M_os,0.0);
   int ksi = 0;
   for(i = 0; i < OrdersTotal(); i++)
     {
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) 
           break;
       //----
       if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
           ksi++;
           M_os[ksi][0] = OrderTicket();
           M_os[ksi][1] = OrderOpenPrice();
           M_os[ksi][2] = OrderLots();
           M_os[ksi][3] = OrderType();
           M_os[ksi][4] = OrderMagicNumber();
           M_os[ksi][5] = OrderStopLoss();
           M_os[ksi][6] = OrderTakeProfit();
           M_os[ksi][7] = OrderProfit();
         }
     } 
   ks_max = kol_sell();
   M_os[0][0] = ks; 
   max_lot_s = M_os[kol_sell()][2];
   sell_lev_max = M_os[kol_sell()][1];
   return;   
  }

//--------------------------------

void buy_open()
  {
   kk = 0; 
   tic = -1;  
   if(max_lot_b == 0.0)
       lotsi = lot;
   else 
       lotsi = dec*max_lot_b;
   //----
   while(tic == -1 && kk < 3)
     {
       tic = OrderSend(Symbol(), OP_BUY, lotsi, Ask, slip, 0, Ask + (tp + tpa)*Point, 
                       " ", m, 0, Yellow);
       Print("tic_buy=", tic);
       //----
       if(tic==-1)
         {
           gle = GetLastError();
           kk++;               
           Print(" ", gle, "  buy ", kk);
           Sleep(6000);
           RefreshRates();   
         }
     }   
   lastt = CurTime();
   buy_array_reset();
   buy++;
   return;
  }

void sell_open()
  {
   tic = -1;
   kk = 0;  
   if(max_lot_s == 0.0)
         lotsi = lot;
     else 
         lotsi = dec*max_lot_s;
     //----
     while(tic == -1 && kk < 3)
       {
         tic = OrderSend(Symbol(), OP_SELL, lotsi, Bid, slip, 0, Bid - (tp + tpa)*Point, 
                         " ", m, 0, Red);
         Print("tic_sell=", tic);
         //----
         if(tic == -1)
           {
             gle = GetLastError();
             kk++;               
             Print(" ", gle, "  sell ", kk);
             Sleep(6000);
             RefreshRates();   
           }
        }
     lastt = CurTime();
     sell_array_reset();
     sell++;
     return;
   }

void buy_close()
  {
   kk = 0;
   ii = 0;
   while(kol_buy() > 0 && kk < 3)
     {
       for(i = 1; i <= kb; i++)
         {
           ii = M_ob[i][0];
           //----
           if(!OrderClose(ii,M_ob[i][2],Bid,slip,White)) 
             {
               gle = GetLastError();
               kk++;
               Print(" ", gle, "  close buy ", kk);
               Sleep(6000);
               RefreshRates();  
             }
         }
       kk++;
     }
   buy_array_reset();
   buy = 0;
   return;
  }

void sell_close()
  {
   kk = 0;  
   ii = 0; 
   while(kol_sell() > 0 && kk < 3)
     {
       for(i = 1; i <= ks; i++)
         {
           ii = M_os[i][0];
           //----
           if(!OrderClose(ii,M_os[i][2], Ask, slip, White))
             {
               gle = GetLastError();
               kk++;
               Print(" ", gle, "  close sell ", kk);
               Sleep(6000);
               RefreshRates();  
             }
         }
       kk++;
     }
   sell_array_reset();
   sell = 0;
   return;
  }

//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void CloseAllOrders()
{   
   while (OrdersTotal()>0)
   {
     if (OrderSelect(0,SELECT_BY_POS,MODE_TRADES))
     {
      int cmd=OrderType();      
      if(cmd==OP_BUY || cmd==OP_SELL)
        {         
            RefreshRates();
            double price;
            if(cmd==OP_BUY) price=MarketInfo( OrderSymbol(), MODE_BID );
            else            price=MarketInfo( OrderSymbol(), MODE_ASK );
            int result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(price,Digits),3,CLR_NONE);
            if(result!=TRUE) 
              { 
                int error=GetLastError(); 
                Print("LastError = ",error); 
              }            
        }
      if (cmd>1) 
      {
            result=OrderDelete(OrderTicket());
            if(result!=TRUE) 
              { 
                error=GetLastError(); 
                Print("LastError = ",error); 
              }  
      } 
     }
     Sleep(500);     
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init() 
  {
   buy = 0;
   sell = 0;
   max_lot_b = 0;
   max_lot_s = 0;
   kb = kol_buy() + 1;
   ks = kol_sell() + 1;
   buy_array_reset();
   sell_array_reset();
   return (0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   
      if (LastDay!=Day()) 
      {
         CanTrade = true;    //   -       
         Comment("     "+ TimeToStr(TimeCurrent(), TIME_DATE) + " : " + NormalizeDouble(Depo,2));
      }   
   
      if (!CanTrade) return(0); //    - 
   
      if (CanTrall && CanTrade)  //    
      {
         if (AccountEquity()<=Depo-FixPart && Position==0)  //     -     .
         {
            CanTrade=false;
            CloseAllOrders();  
            Position = 0;       //            
            Depo = AccountEquity();
            Comment("   .   " + "\n" + 
                    "= " + AccountBalance() );   
            return(0);   
         }  

         //          
         if (AccountEquity()>Depo+Eq1) Position=1;
         if (AccountEquity()>Depo+Eq2) Position=2;
         if (AccountEquity()>Depo+Eq3) Position=3;
         if (AccountEquity()>Depo+Eq4) Position=4;
         if (AccountEquity()>Depo+Eq5) Position=5;
         if (AccountEquity()>Depo+Eq5+FixPart && Position!=6) 
         {       
           Position=6;
           Depo = Depo+Eq5;
           var = AccountEquity();
         }  
          
         if (Position==1 && AccountEquity()<Depo+Tral1) CanTrade=false;
         if (Position==2 && AccountEquity()<Depo+Tral2) CanTrade=false;
         if (Position==3 && AccountEquity()<Depo+Tral3) CanTrade=false;
         if (Position==4 && AccountEquity()<Depo+Tral4) CanTrade=false;
         if (Position==5 && AccountEquity()<Depo+Tral5) CanTrade=false;
     
         if (Position==6)
         {
            if (AccountEquity()>var+DeltaEQ)  
            {
              var = AccountEquity();
              Depo = Depo+Tral6;
            }  
            if (AccountEquity()<Depo)  CanTrade=false;
         }
     
         if (CanTrade==false)
         {     
           CloseAllOrders();  //  -          
           Depo = AccountEquity();
           Comment(" "+Position+"-  .   " + "\n" + 
                   "= " + AccountBalance() );   
           Position = 0;      //             
           return(0);   
         }     
      }
   
   if(IsTradeAllowed() == false) 
       return(0); 

   if ((kol_buy())!=buy) 
       {
       buy_array_reset();
       buy = kol_buy(); 
       }
   if ((kol_sell())!=sell)
       {
       sell_array_reset();
       sell = kol_sell();
       }
//----

   sob = (kol_buy() < 1 || buy_lev_min - sh*Point > Ask) && 
          AccountFreeMargin() > AccountBalance()*balance;
   sos = (kol_sell() < 1 || sell_lev_max + sh*Point < Bid) &&
          AccountFreeMargin() > AccountBalance()*balance;

//----
   if(M_ob[kb_max][2] > 0.0)
       scb = M_ob[kb_max][7] / (M_ob[kb_max][2]*10) > tp;
//----
   if(M_os[ks_max][2] > 0.0)
       scs = M_os[ks_max][7] / (M_os[ks_max][2]*10) > tp;

//----

   if(scb)buy_close();
   if(scs)sell_close();

//----

   if(sob) buy_open();
   if(sos) sell_open();

//----

   LastDay = Day();
   return(0);     
  }
//+------------------------------------------------------------------+   


